#pragma once

#include <fstream>
#include <map>

class OE_curve;
class OE_thread;

class OE_ifstream : public std::ifstream
{
	public:
		OE_ifstream(std::string path) : std::ifstream(path)
		{
		}
		std::map<int, OE_curve*> curvePointers;
		std::map<int, OE_thread*> threadPointers;
};

class OE_ofstream : public std::ofstream
{
	public:
		OE_ofstream(std::string path) : std::ofstream(path)
		{
		}
		std::map<OE_curve*, int> curveIds;
		std::map<OE_thread*, int> threadIds;
};

