/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#pragma once

#include "actions/OE_actions.h"
#include "OE_thread.h"

class OE_actionNewThread : public OE_actions
{
	public:
		OE_actionNewThread(OE_document* doc, OE_thread* thread);

		virtual ~OE_actionNewThread();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
};

class OE_actionDelThread : public OE_actions
{
	public:
		OE_actionDelThread(OE_document* doc, OE_thread* thread);

		virtual ~OE_actionDelThread();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
};

class OE_actionThreadColor : public OE_actions
{
	public:
		OE_actionThreadColor(OE_document* doc, OE_thread* thread, OE_color color);

		virtual ~OE_actionThreadColor();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
		OE_color oldColor;
};

class OE_actionThreadWidth : public OE_actions
{
	public:
		OE_actionThreadWidth(OE_document* doc, OE_thread* thread, float width);

		virtual ~OE_actionThreadWidth();

		virtual void undo();
		virtual void redo();

	protected:
		OE_thread* actionThread;
		float oldWidth;
};

//bool setThreadColor(unsigned index, unsigned char r, unsigned char g, unsigned char b );
//bool setThreadWidth(unsigned index, float width );

