%include "std_string.i"
%include "std_vector.i"
%include "std_list.i"

%module oe
%{
#include "include/OE_document.h"
#include "include/OE_utils.h"
#include "include/OE_base.h"
#include "include/OE_display.h"
#include "include/OE_commandDisplay.h"
#include "include/OE_interfaceDisplay.h"
#include "include/OE_editDisplay.h"
#include "include/OE_thread.h"
#include "include/OE_controller.h"
#include "include/OE_instruction.h"
#include "include/OE_svgParser.h"
#include "include/instructions/OE_instruction.h"
#include "include/instructions/OE_waitcolor.h"
#include "include/instructions/OE_start.h"
#include "include/curves/OE_curve.h"
#include "include/curves/OE_subcurve.h"
#include "include/curves/OE_pointcurve.h"
#include "include/curves/OE_joincurve.h"
#include "include/xml/tinyxml.h"
#include "include/xml/tinystr.h"
#include "include/stitchs/OE_stitchs.h"
#include "include/stitchs/OE_linkstitch.h"
#include "include/stitchs/OE_birailstitch.h"
#include "include/stitchs/OE_linestitch.h"
#include "include/stitchs/OE_metaLinestitch.h"
#include "include/actions/OE_actions.h"
#include "include/actions/OE_actionsThreads.h"
#include "include/actions/OE_actionsBirailStitchs.h"
#include "include/actions/OE_actionsCurves.h"
#include "include/actions/OE_actionsStitchs.h"
#include "include/actions/OE_actionsSelection.h"
#include "include/actions/OE_actionsLineStitchs.h"
#include "include/actions/OE_actionsMetaLineStitchs.h"
#include "include/main.h"
%}

%include "include/OE_document.h"
%include "include/OE_utils.h"
%include "include/OE_base.h"
%include "include/OE_display.h"
%include "include/OE_commandDisplay.h"
%include "include/OE_interfaceDisplay.h"
%include "include/OE_editDisplay.h"
%include "include/OE_thread.h"
%include "include/OE_controller.h"
%include "include/OE_instruction.h"
%include "include/OE_svgParser.h"
%include "include/instructions/OE_instruction.h"
%include "include/instructions/OE_waitcolor.h"
%include "include/instructions/OE_start.h"
%include "include/curves/OE_curve.h"
%include "include/curves/OE_subcurve.h"
%include "include/curves/OE_pointcurve.h"
%include "include/curves/OE_joincurve.h"
%include "include/xml/tinyxml.h"
%include "include/xml/tinystr.h"
%include "include/stitchs/OE_stitchs.h"
%include "include/stitchs/OE_linkstitch.h"
%include "include/stitchs/OE_birailstitch.h"
%include "include/stitchs/OE_linestitch.h"
%include "include/actions/OE_actions.h"
%include "include/actions/OE_actionsThreads.h"
%include "include/actions/OE_actionsBirailStitchs.h"
%include "include/actions/OE_actionsCurves.h"
%include "include/actions/OE_actionsStitchs.h"
%include "include/actions/OE_actionsSelection.h"
%include "include/actions/OE_actionsLineStitchs.h"
%include "include/actions/OE_actionsMetaLineStitchs.h"
%include "include/main.h"

/*
gcc -c oe.c oe_wrap.c -I/usr/local/include/python2.1
ld -shared oe.o eo_wrap.o -o _eo.so
import oe

swig -python -Iinclude -c++ oe.i
g++ -fPIC -shared -std=c++11 -Iinclude $(pkg-config --cflags python3) main.cpp oe_wrap.cxx $(find src -name "*.cpp") -rdynamic -lGLU -lGL -lglfw -lrt -lm -ldl -lXrandr -lXinerama -lXi -lXcursor -lXrender -lGL -lm -lpthread -ldl -ldrm -lXdamage -lXfixes -lX11-xcb -lxcb-glx -lxcb-dri2 -lxcb-dri3 -lxcb-present -lxcb-randr -lxcb-xfixes -lxcb-render -lxcb-shape -lxcb-sync -lxshmfence -lXxf86vm -lXext -lX11 -lpthread -lxcb -lXau -lXdmcp -lpthread -lm -lbluetooth -ldl -lXrandr -lXinerama -lXi -lXcursor -lXrender -lGL -lpthread -ldrm -lXdamage -lXfixes -lX11-xcb -lxcb-glx -lxcb-dri2 -lxcb-dri3 -lxcb-present -lxcb-randr -lxcb-xfixes -lxcb-render -lxcb-shape -lxcb-sync -lxshmfence -lXxf86vm -lXext -lX11 -lxcb -lXau -lXdmcp -lpthread -lbluetooth -o _oe.so
*/

