/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#include "stitchs/OE_staticstitch.h"

OE_staticstitch::OE_staticstitch(OE_thread* thread)
{
	this->thread = thread;
}

void OE_staticstitch::persist(Pakal::Archive* archive)
{
	OE_stitchs::persist(archive);
	archive->set_type_name("OE_staticstitch");
	archive->value("pts", pts);
}

void OE_staticstitch::move(vector_2d offset)
{
	for (unsigned i=0; i<pts.size(); i++)
	{
		pts[i] = pts[i] + offset;
	}
	setNeedRefresh();
}

